=== debian/changelog ===
akonadi (4:19.12.3-0ubuntu2) focal; urgency=medium

  * libkf5akonadicore-bin: Drop transitional depends on akonadi-server.
    This unnecessarily installs the whole server for apps that only
    require the core libs. (LP: #1872890)

 -- Rik Mills <rikmills@kde.org>  Wed, 15 Apr 2020 11:35:48 +0100

akonadi (4:19.12.3-0ubuntu1) focal; urgency=medium

  * New upstream release (19.12.3)
  * Refresh patches.
  * Move qdebug categories file to new location.
  * Move kdevappwizard templates to -dev package.
  * Move asapcat binary to -dev package.
  * Make libkf5akonadicore-bin package transitional, and move
    akonadiselftest binary to main akonadi-server package.
  * Move translations to new libkf5akonadi-data package.
  * Demote akonadi-backend-mysql to Recommends.
  * Follow Debian ABI bump:
    - libkf5akonadicore5abi1 -> libkf5akonadicore5abi2
  * Add optional build depends for kaccounts integration.
    - libaccounts-qt5-dev, libkaccounts-dev & libaccounts-glib-dev
  * Switch to using upstream provided apparmor profiles.
  * Add fix-apparmor-profiles.patch
  * Update install files.
  * Update symbols from build logs.

 -- Rik Mills <rikmills@kde.org>  Sun, 12 Apr 2020 16:09:52 +0100

akonadi (4:19.04.3-0ubuntu6) focal; urgency=medium

  * No-change rebuild against qtbase-abi-5-12-8.

 -- Rik Mills <rikmills@kde.org>  Sat, 11 Apr 2020 13:06:20 +0100

akonadi (4:19.04.3-0ubuntu5) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 23 Mar 2020 07:09:29 +0100

akonadi (4:19.04.3-0ubuntu4) focal; urgency=medium

  * No-change rebuild againts qtbase-abi-5-12-5

 -- Rik Mills <rikmills@kde.org>  Sat, 26 Oct 2019 11:33:57 +0100
